
/*
 * Приклади роботи з Smart IR
 * ПРІКЛАД ПРОГРАМУВАННЯ 4 КНОПОК ДЛЯ 1 ПУЛЬТА
 * Для програмування кнопок пульта набтати "зірочку"
 * Цифрами від 1 до 4 вибирається програмування однієї кнопки для однієї команди 
 * Потім потрібно натискати необхідну кнопку пульта для програмування.
 * На період програмування загоряється індикатор. Періодично гасне, коли отриманий код
 * від пульта прийнято.Необхідно тримати пульт як найближче доІЧ-приймача щоб код
 * коректно був прийнятий і запрограмований.
 * Smart IR приймає 5 кодів від пульта і запам'ятовує, який більше присутній.
 * Він вважається правильним. При необхідності можливо повторити програмування.
 * Якщо всі кнопки пульта запрограмовані і перевірено їх правільність роботи, а
 * це можливо перевірити натиснувши "с", має бути код команди для запрограмованої
 * кнопки пульта. Кнопка "S" збереже створений масив в Smart IR для подальшого
 * використання.
 * Інші команди
 * r - номер пульта
 * с - номер команди
 * i - 32-бітний декодований код прийнятий від пульта 
 * t - масив T-кодів. 
 * G - приклад збереження конфігураційних параметрів.
 * S - збереження масиву кодів для запрограмованих кнопок пульта.
 */
/*  IIC  */
//#include <smartir2iic.h>
//smartir2iic sm(0x66);
/* End IIC */

/* Serial */
#include <smartir2ser.h>
#include <SoftwareSerial.h>

SoftwareSerial ss(11,12); //rx,tx
smartir2ser sm(&ss,19200);
/* End Serial */

uint8_t arr[128];
int ln;
void setup() {
  sm.begin();
  Serial.begin(19200);
  sm.name(arr);
  Serial.print("Name "); Serial.println((char*) arr);
  sm.version(arr);
  Serial.print("Ver. "); Serial.println((char*) arr);
}

void loop() {
  if(Serial.available()>0) {
    char c = Serial.read();
    switch(c) {
      case '*':
        Serial.println("Create: RC = 1,Cmd = 4");
        sm.create(1,4);
      break;
      case '1':
        Serial.println("Edit: RC = 1,Cmd = 1");
        sm.edit(1,1);  
      break;  
      case '2':
        Serial.println("Edit: RC = 1,Cmd = 2");
        sm.edit(1,2);
      break;
      case '3':
        Serial.println("Edit: RC = 1,Cmd = 3");
        sm.edit(1,3);
      break;
      case '4':
        Serial.println("Edit: RC = 1,Cmd = 4");
        sm.edit(1,4);
      break; 
      case 'r':
        Serial.print("RC = ");
        Serial.println(sm.rc(),DEC);      
      break;
      case 'c':
        Serial.print("Cmd = ");
        Serial.println(sm.cmd(),DEC);       
      break;
      case 'i':
        Serial.print("Code = "); Serial.println(sm.code(),HEX);
      break;
      case 't':
        ln=sm.tCode(arr);
        Serial.print("T-Code: "); Serial.println(ln,DEC);
        Serial.print("(HEX): ");
        for(int i=0;i<ln;i++) {
          if(arr[i]<16) Serial.print("0");
          Serial.print(arr[i],HEX);
        }
        Serial.println("");
      break;
      case 'G':
        Serial.print("Save Config...");
        byte _addr = 0x66;        //адреса I2C
        uint32_t _speed = 19200;  //швидкість UART
        byte mLed = 1;            // режим роботи індикатора
        byte lLed = 255;          //яскравість індикатора  
        if(sm.saveConf(_addr,_speed,mLed,lLed)) Serial.println("OK");
        else Serial.println("Error");
      break;
      case 'S':
        Serial.print("Save Code...");
        if(sm.saveCode()) Serial.println("OK");
        else Serial.println("Error");
      break;
    }
  }
}
