//
// smartir2ser.h
//

#ifndef smartir2ser_h
#define smartir2ser_h

#include "SoftwareSerial.h"
#include "Arduino.h"

class smartir2ser {
  public:
    smartir2ser(SoftwareSerial * ss, uint32_t speed);
    smartir2ser(uint32_t speed);
    void begin(void);
    uint8_t cmd(void);
    uint8_t rc(void);
    uint32_t code(void);
    uint8_t protocol(void);
    bool create(uint8_t rc, uint8_t cmd);
    bool edit(uint8_t rc, uint8_t cmd);
    bool setModeLed(uint8_t stat);
    bool setLightLed(uint8_t light);
    uint8_t tCode(uint8_t *data);
    bool decode1(uint8_t m0, uint8_t s0, uint8_t m1, uint8_t s1, uint8_t offset, uint8_t ln);
    bool decode2(bool phase, uint8_t offset, uint8_t ln);
    uint8_t addr(void);
    uint32_t speed(void);
    uint8_t modeLed(void);
    uint8_t lightLed(void);
    bool saveConf(uint8_t addr, uint32_t speed, uint8_t led, uint8_t light);
    bool clearConf(void);
    bool saveCode(void);
    bool clearCode(void);
    uint8_t name(uint8_t *data);
    uint8_t version(uint8_t *data);
    void reboot(void);
 private:
    uint8_t _addr, _led, _light;
    uint32_t _speed;
    uint8_t _arr[12];

    SoftwareSerial *_Serial;
    void _p0r0(uint8_t cmd);
    void _p0r1(uint8_t cmd);
    void _p0r2(uint8_t cmd);
    void _p0r4(uint8_t cmd);
    void _p0r5x(uint8_t cmd);
    void _p0r8(uint8_t cmd, uint8_t *data);
    void _p1r1(uint8_t cmd, uint8_t d1);
    void _p2r1(uint8_t cmd, uint8_t d1, uint8_t d2);
    void _p0rN(uint8_t cmd, uint8_t *data);
    void _p4r1(uint8_t cmd, uint8_t *data);
    void _p7r1(uint8_t cmd, uint8_t *data);
  
    uint8_t _chk_s(uint8_t *a, byte n);
}; 

#endif /* defined(phdb_ser_h) */


